﻿function initClearNameFilterSearch() {
    changed = false;
    // search box
    $('#filterTextbox').on('keyup', document, function () {
        // show/hide the clear selection icon
        if ($(this).val().length == 0) {
            $(".clearSearchIcon").hide();
        }
        else {
            $(".clearSearchIcon").show();
        }
    });

    $(".clearSearchIcon").on('click', document, function (event) {
        event.preventDefault();
        $('#filterTextbox').val("");
        changed = true;
        $(".clearSearchIcon").hide();
        $('.search-bar #filterTextbox').trigger('keyup');
    });

    $(document).mousedown(function (e) {
        if ($(e.target).hasClass('clearSearchIcon')) {
            changed = false;
        }
    });
}

function SelectItems(all) {
    var selector = ".item:visible";
    $(selector, contextForSingleItems).each(function () {
        all ? $(this).addClass('selected') & $(this).find(".check").addClass('on') : $(this).removeClass('selected') & $(this).find(".check").removeClass('on');
    })
}

function TriggerNameFiltering() {
    $('#multipleSelectModal #filterTextbox').keyup();
}

$("ul#itemsContainer .item").click(function () {
    $(this).toggleClass('selected');
    $(this).find(".check").toggleClass('on');
});

function ClearFilters() {
    $('.item .checkboxContainer', contextForGroups).each(function () {
        var $that = $(this);
        $that.parent().removeClass('selected');
        $('input', $that).val(false);
        $('span', $that).hide();
    })
    ShowAll();
    TriggerNameFiltering();
    CalculateGroupItems(false);
}

function ShowAll() {
    $(".item", contextForSingleItems).addClass('active').show();
}

function HideAll() {
    $(".item", contextForSingleItems).hide().removeClass('active');
}

function Filter() {
    var checkboxes = $("input:checkbox[value='true']", contextForGroups);
    checkboxes.each(function () {
        var $checkbox = $(this);
        var catId = $checkbox.attr('id');
        $('.item', contextForSingleItems).filter(function () {
            return $(this).data('cat') == catId;
        }).show().addClass('active');
    });

    if (checkboxes.length == 0) {
        ShowAll();
    }
};

function CalculateGroupItems(includeNonVisible) {

    var filters = $('.item input', '#filteritemsContainer'),
    selector = jQuery.validator.format('.item{0}[data-cat={1}]');
    
    filters.each(function (val, index) {
        var $that = $(this);
        var id = $that.attr('id');
        $that.parent().siblings('.count').html($(selector((includeNonVisible ? "" : ":visible"), id), '#itemsContainer').length);
    })
}

$(document).ready(function () {
    mutipleSelectForEntity = $('#multipleSelectModal').data('forentitytype');
    mutipleSelectForPanel = $('#multipleSelectModal').data('forpanel');
    contextForSingleItems = $('#multipleSelectModal #itemsContainer');
    contextForGroups = $('#multipleSelectModal #filteritemsContainer');
    CalculateGroupItems(true);

    $('input', contextForGroups).each(function () {
        $(this).change(function () {
            HideAll();
            Filter();
            TriggerNameFiltering();
        })
    })

    $('#itemsContainer').liveFilter('#multipleSelectModal #filterTextbox', 'li.active', {
        filterChildSelector: '.title',
        before: function () { },
        after: function () { CalculateGroupItems(false); }
    });

    $('#addToPolicy').click(function () {
        $('.item.selected .itemContent .title', contextForSingleItems).each(function () {
            var itemToAdd = $(this).text();
            AddToPolicy(mutipleSelectForPanel, mutipleSelectForEntity, itemToAdd.replace(new RegExp(' / ', 'g'), '/'));
        });
        $('#multiSelectHolder').foundation('reveal', 'close');
    })

    $('.button.cancel, a#closeLink').click(function () {
        $('#multiSelectHolder').foundation('reveal', 'close');
    })

    $("#multipleSelectModal #actionsDropdown > li > a").each(function () {
        $(this).click(function () {
            switch ($(this).attr('id')) {
                case 'slectedAll': SelectItems(true); break;
                case 'selectNone': SelectItems(false); break;
                case 'clearFilters': ClearFilters(); break;
                case 'clearFiltersbtn': ClearFilters(); break;
            }
        })
    })

    $("#multipleSelectModal .dropdownBtn").click(function (event) {
        $('.dropdown.zoom', this).toggleClass("hide");
        event.stopPropagation();
    });

    $(document).click(function (event) {
        $(".dropdown.zoom").addClass("hide");
    });

    $("input:checkbox", "#modalSideBar").change(function (event) {
        if ($(this).attr("value") == 'true') {
            $(this).parents('li').addClass('selected')
        }

        else if ($(this).attr("value") == 'false') {
            $(this).parents('li').removeClass('selected')
        }
    });

    $('#clearFiltersbtn').click(function () {
        ClearFilters();
    });

    initClearNameFilterSearch();
});